/* jshint asi: true */
/* jshint esversion: 6 */
/* jshint node: true */
/* jshint jquery: true */
/* jshint strict: false */
/* jshint eqeqeq: false */
//-----------------------------------------------------------------
var pParser             = null
var sFile               = null
var pXML                = null
var pAssetObjects       = null
//-----------------------------------------------------------------
// XML Parsing functions
//-----------------------------------------------------------------
function IsElement(pElement){
	return pElement.q(":scope > m_Name") !== null
}

function GetElementParams(pLI) {
	var pXML_Node = pLI.XML_Node
	var tTable = []

	let pName	= pXML_Node.q(":scope > m_Name"); if (pName){
		pName.Refresh = pLI
		tTable.push(pName)
	}
	let pRMCE	= pXML_Node.q(":scope > m_ReplaceMergedCollectionElements"); if (pRMCE){tTable.push(pRMCE)}

	let pValues = pXML_Node.qa(":scope > m_Fields > m_Values > Element")
	for (pValue of pValues.values()){
		if (pValue.getAttribute("class").GetCoreClass() != "CollectionValue"){
			tTable.push(pValue)
		}
	}

	return tTable
}

function GetElementCollections(pLI) {
	var pXML_Node = pLI.XML_Node
	var tChildren = []

	// Don't continue if the LI isn't a final LI in the tree
	if (pLI.qa("sidebarlist-li").length > 0){return [pXML_Node, tChildren]}

	// AssetObject..CollectionValue First
	if (pXML_Node.q(":scope > m_Fields > m_Values > [class$=\"CollectionValue\"]") !== null){
		tChildren = pXML_Node.qa(":scope > m_Fields > m_Values > [class$=\"CollectionValue\"] > m_Values > Element")
		return [pXML_Node, tChildren]
	}
	
	// Child Collections
	if (pXML_Node.parentElement.tagName === "m_ChildCollections"){
		tChildren = pXML_Node.qa(":scope > Element")
		return [pXML_Node, tChildren]
	}

	return [pXML_Node, tChildren]
}
//-----------------------------------------------------------------
// Sidebar Generation
//-----------------------------------------------------------------
function GenerateTree(pAssetObjects) {
	var pList = document.getElementById("sidebarlist") //Root UL
	var pRootCollections = pAssetObjects.qa("m_RootCollections > Element")
	pList.innerHTML = ""

	// Root collections are handled differently
	// First, get each Root Collection
	//-----------------------------------------------------------------
	// Root Collections
	//-----------------------------------------------------------------     
	for (let pCollection of pRootCollections.values()){

		let sName = pCollection.q(":scope > m_CollectionName").getAttribute("text")
		let pLI = document.createElement("sidebarlist-li").def(sName, pCollection, true)
		pLI.classList.add("RootCollection");
		pList.appendChild(pLI)

		//-----------------------------------------------------------------
		// Children
		//-----------------------------------------------------------------     
		let pChildren = pCollection.qa(":scope > Element") 

		for (let pChild of pChildren.values()){
			AppendChild(pLI, pChild)
		}
		//-----------------------------------------------------------------
		//-----------------------------------------------------------------
	}
}

function AppendChildCollections(pDOM, pElement) {

	var pChildren = pElement.qa(":scope > m_ChildCollections > Element, :scope > Element"); pChildren = Array.from(pChildren)

	var pAssetCollections = pElement.qa(":scope > Element > m_Fields > m_Values > [class$=\"CollectionValue\"]")
	for (let pChild of pAssetCollections.values()){
		let pParent = pChild.parentElement.parentElement.parentElement
		if (! pChildren.includes(pParent)){
			pChildren.push(pParent)
		}
	}	

	// Create an entry for each Child
	if (pChildren.length > 0) {
		for (let pChild of pChildren.values()){
			AppendChild(pDOM, pChild)
		}
	}

	return pDOM
}

function AppendChild(pDOM, pElement){
	var pUL = pDOM.q("ul")

	if (pElement.innerHTML === ""){return}

	var pName = pElement.q(":scope > m_CollectionName") || pElement.q(":scope > m_Name")
	var sName = pName.getAttribute("text")
	let pLI = document.createElement("sidebarlist-li").def(sName, pElement);
	if (pElement.q(":scope m_ChildCollections") !== null && pElement.q(":scope m_ChildCollections").innerHTML !== ""){
		AppendChildCollections(pLI, pElement)
	} else if (pElement.q("[class$=\"CollectionValue\"]") !== null){
		AppendChildCollections(pLI, pElement)
	}

	if (IsElement(pElement)){
		pLI.q("li").classList.add("elementLI");
	}

	pUL.appendChild(pLI)
	return pLI
}
//-----------------------------------------------------------------
//  References Editor
//-----------------------------------------------------------------
var pRefEditor = document.getElementById("reference_editor")
var pRefTable = pRefEditor.q("table")

var tRef_ElementstoIgnore = [
	//'m_ParamName',
	//'m_TemplateName',
]

var _pointerup = 'touchend.RefEdit mouseup.RefEdit pointerup.RefEdit'

function GenerateReferences(pParent, pXML_Node){

	var jRefEditor = $(pRefEditor)
	var jParent = $(pParent)
	$(document).on(_pointerup, function(e) {
		if (!jParent.is(e.target) && !jRefEditor.is(e.target) && jRefEditor.has(e.target).length === 0) {
			if (e.target.Type !== "RefEditor"){
				$(document).off('.RefEdit');
				jRefEditor.hide(150)
			}
		}
	})

	jRefEditor.show(150)
	var tOffset = jParent.offset(); tOffset.top = tOffset.top + jParent.outerHeight()
	jRefEditor.offset(tOffset)

	//-----------------------------------------------------------------
	// Adjust width
	//-----------------------------------------------------------------

	pRefTable.innerHTML = ""
	for (let pParam of pXML_Node.children){
		if (!tRef_ElementstoIgnore.includes(pParam.tagName)){
			var tRow = document.createElement("tr");

			let {sName, sType}		= GetParamInfo(pParam)
			tRow.Name				= sName
			tRow.Type				= sType
			tRow.XML_Node			= pParam
			if (pParent.MainName == tRow.Name){
				pParam.Refresh = pParent
			}

			var tLabel = document.createElement("td"); tLabel.innerHTML = tRow.Name 
			var tControl = document.createElement("td")
			var tInput = document.createElement("param-input").def(tRow.Name, tRow.Type, pParam)

			tControl.appendChild(tInput)
			tRow.appendChild(tLabel); tRow.appendChild(tControl)
			pRefTable.appendChild(tRow)         
		}
	}

	for (let tInput of pRefTable.qa('input').values()){
		$(tInput).on("change paste keyup", function(){
			pParent.onValueChange(pParent.q('input'))
		})
	}
}
//-----------------------------------------------------------------
// Parameters
//-----------------------------------------------------------------
var pParamsTable = null

function GetParamInfo(pParam) {
	let sName = pParam.tagName
	let sType = "StringValue_Attr"

	if (pParam.innerHTML == "true" || pParam.innerHTML == "false"){
		sName = pParam.tagName
		sType = 'SimpleBoolValue'
	}

	if (sName == "Element"){
		sName = pParam.q("m_ParamName").getAttribute("text")
		sType = pParam.getAttribute("class").GetCoreClass()
	}

	return {sName, sType}
}

function GenerateParams(tParams) {

	var pPanel = document.getElementById("param_table_slot")
	pPanel.innerHTML = ""; pParamsTable = null
	//-----------------------------------------------------------------
	// Create Table
	//-----------------------------------------------------------------
	pParamsTable = document.createElement("param-table")

	for (var pParam of tParams){
		let {sName, sType} = GetParamInfo(pParam)

		pParamsTable.addParam(sName, sType, pParam)
	}
	//-----------------------------------------------------------------
	//-----------------------------------------------------------------
	pPanel.appendChild(pParamsTable)
}
//-----------------------------------------------------------------
// Collections
//-----------------------------------------------------------------
var pCollecTable = null

function GenerateCollection([pXML_Node, tChildren]) {

	// Clear the Table
	var pPanel = document.getElementById("collec_table_slot")
	pPanel.innerHTML = ""; pCollecTable = null
	pPanel.style.display = 'none'

	// Are there even any children?
	if (tChildren.length < 1){return}

	// Check whether its CollectionValues or ChildCollection
	var bIsCV = tChildren[0].parentElement.tagName == "m_Values"
	//----------------------------------------------------------------------------------------------------//
	// Get Parameter Types
	//----------------------------------------------------------------------------------------------------//
	var tTypes = []
	//-----------------------------------------------------------------
	// CollectionValues
	//-----------------------------------------------------------------
	if (bIsCV){
		// tTypes.push([
		// 	'm_ParamName',
		// 	'StringValue_Attr'
		// ])
		tTypes.push([
			tChildren[0].parentElement.parentElement.q("m_eValueType").innerHTML,
			tChildren[0].getAttribute("class").GetCoreClass()
		])
	//-----------------------------------------------------------------
	// ChildCollection
	//-----------------------------------------------------------------		
	} else {

		let tParamNames = []; tParamNames.push('m_Name')
		tTypes.push([
			'm_Name',
			'StringValue_Attr'
		])

		for (let tChild of tChildren.values()) {
			let tChildParams = tChild.qa(":scope > m_Fields > m_Values > Element")

			for (let tChildParam of tChildParams.values()){
				let sName = tChildParam.q("m_ParamName").getAttribute("text")
				let sType = tChildParam.getAttribute("class").GetCoreClass()
				let tParam = [sName, sType]

				if (!tParamNames.includes(sName)){
					tParamNames.push(sName)
					tTypes.push(tParam)
				}
			}
		}		
	}
	//----------------------------------------------------------------------------------------------------//
	// Create Table
	//----------------------------------------------------------------------------------------------------//
	pCollecTable = document.createElement("collec-table"); pPanel.appendChild(pCollecTable);
	pCollecTable.defineTypes(tTypes, pXML_Node, bIsCV)
	pCollecTable.generateRows(tChildren)
	//----------------------------------------------------------------------------------------------------//
	//----------------------------------------------------------------------------------------------------//
	pPanel.style.display = 'block'
}
//-----------------------------------------------------------------
// OpenFile
//-----------------------------------------------------------------
var g_CurrentFile = 'assets/Landmarks.artdef'

function OpenFile(sPath) {
	g_CurrentFile = sPath
	pParser = new DOMParser();
	sFile = fs.readFileSync(sPath, "utf8"); sFile = sFile.CleanClasses()
	pXML = pParser.parseFromString(sFile, "application/xml"); if (pXML.q("parsererror")){pXML.q("parsererror").remove()};
	pAssetObjects = pXML.children[0]

	document.getElementById("param_table_slot").innerHTML = ""
	document.getElementById("collec_table_slot").innerHTML = ""
	document.getElementById("collec_table_slot").style.display = 'none'

	GenerateTree(pAssetObjects)
}
electron.ipcRenderer.on('OpenFile', 
	function(event, sFile) {
		if(sFile[0]){OpenFile(sFile[0])}
	}
);
electron.ipcRenderer.on('ReOpenFile', 
	function(event, sFile) {
		OpenFile(g_CurrentFile)
	}
);
//-----------------------------------------------------------------
// SaveFile
//-----------------------------------------------------------------
function SaveFile(sPath) {
	var sDoc = '<?xml version="1.0" encoding="UTF-8" ?>\n' + pXML.documentElement.outerHTML
	sDoc = sDoc.CleanClasses()
	fs.writeFile(sPath, sDoc, 'utf8', (err) => {  
	    // throws an error, you could also catch it here
	    if (err) {throw err; alert(err)}
	    // success case, the file was saved
	    console.log("save sucessful")
	    g_CurrentFile = sPath
	})
}
electron.ipcRenderer.on('SaveFile', 
	function(event, sFile) {
		if(sFile){SaveFile(sFile)}
	}
);
//-----------------------------------------------------------------
// Initialise
//-----------------------------------------------------------------
OpenFile('resources/app/assets/Landmarks.artdef')