/* jshint asi: true */
/* jshint esversion: 6 */

const {
	app,
	BrowserWindow,
	Menu,
	dialog,
} = require('electron')
	
// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the JavaScript object is garbage collected.
let win

function createWindow () {
	// Create the browser window.
	win = new BrowserWindow({ width: 800, height: 600 })
	win.maximize()

	// and load the index.html of the app.
	win.loadFile('index.html')

	//menu bar
	var menu = Menu.buildFromTemplate([
		{
			label: 'File',
				submenu: [
				//-----------------------------------------------------------				
				{
					label:'Open',
					click() { 
						
						let sFile = dialog.showOpenDialog(
							{
								properties: ['openFile'],
								//accelerator: 'Shift+O',
								filters: [
									{name: 'ArtDefs', extensions: ['artdef', 'xml']},
									{name: 'All Files', extensions: ['*']}
								]
							}
						)
						win.webContents.send('OpenFile', sFile)

					} 
				},
				{
					label:'Reopen Current File',
					accelerator: 'Alt+R',
					click() { 
						win.webContents.send('ReOpenFile')
					} 
				},				
				{
					label:'Save As',
					accelerator: 'CmdOrCtrl+S',
					click() { 
						
						let sFile = dialog.showSaveDialog(
							{
								filters: [
									{name: 'ArtDefs', extensions: ['artdef', 'xml']},
									//{name: 'All Files', extensions: ['*']}
								]
							}
						)
						win.webContents.send('SaveFile', sFile)

					} 
				},
				//-----------------------------------------------------------				
				{
					label:'Exit', 
					click() { 
						app.quit() 
					} 
				}
			]
		},
		// {
		// 	label: 'Edit',
		// 	submenu: [
		// 		{ role: 'undo' },
		// 		{ role: 'redo' },
		// 		{ type: 'separator' },
		// 		{ role: 'cut' },
		// 		{ role: 'copy' },
		// 		{ role: 'paste' },
		// 		{ role: 'pasteandmatchstyle' },
		// 		{ role: 'delete' },
		// 		{ role: 'selectall' }
		// 	]
		// },
		{
			label: 'View',
			submenu: [
				{ role: 'reload' },
				{ role: 'forcereload' },
				{ role: 'toggledevtools' },
				// { type: 'separator' },
				// { role: 'resetzoom' },
				// { role: 'zoomin' },
				// { role: 'zoomout' },
				{ type: 'separator' },
				{ role: 'togglefullscreen' }
			]
		},
		{
			role: 'window',
			submenu: [
				{ role: 'minimize' },
				{ role: 'close' }
			]
		},
		// {
		// 	role: 'help',
		// 	submenu: [
		// 		{
		// 			label: 'Learn More',
		// 			click () { require('electron').shell.openExternal('https://electronjs.org') }
		// 		}
		// 	]
		// }			
	])
	Menu.setApplicationMenu(menu)

	// Emitted when the window is closed.
	win.on('closed', () => {
		// Dereference the window object, usually you would store windows
		// in an array if your app supports multi windows, this is the time
		// when you should delete the corresponding element.
		win = null
	})
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.on('ready', createWindow)

// Quit when all windows are closed.
app.on('window-all-closed', () => {
	// On macOS it is common for applications and their menu bar
	// to stay active until the user quits explicitly with Cmd + Q
	if (process.platform !== 'darwin') {
		app.quit()
	}
})

app.on('activate', () => {
	// On macOS it's common to re-create a window in the app when the
	// dock icon is clicked and there are no other windows open.
	if (win === null) {
		createWindow()
	}
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.